/*
 * Interrupt-Handlingroutine fr 2,5-stelliges 7-Segmentdisplay LTC 4622 
 *
 * Letzte Modifikation: 06.05.2013
 * Author: Falko Glanert, DG1AFG
*/

    static uint8_t Anode;									// Anodenzhler
	
// 7-Segment Decodiertabelle
    static const uint8_t decode[] PROGMEM = { 	0xc7, 0xc7, /* 0 */ \
                                            0xcf, 0xff, /* 1 */ \
                                            0xe7, 0xa7, /* 2 */ \
                                            0xc7, 0xb7, /* 3 */ \
                                            0xcf, 0x9f, /* 4 */ \
                                            0xd7, 0x97, /* 5 */ \
                                            0xd7, 0x87, /* 6 */ \
                                            0xc7, 0xff, /* 7 */ \
                                            0xc7, 0x87, /* 8 */ \
                                            0xc7, 0x97, /* 9 */ \
                                            0xff, 0xbf  /* Strich */
                                            };

    TCNT0 = TCNT0_Reload;									// Reload Timer
// Anoden und Segmente aus !
    PORTA |= (1<<PA2) | (1<<PA3) | (1<<PA4) | (1<<PA5) | (1<<PA6) | (1<<PA7);
    PORTB |= (1<<PB0) | (1<<PB1) | (1<<PB2);
    Anode++;												// Nchste Stelle
    if (Anode>3) Anode=0;									// MUX-Ende?
// Da Display nun dunkel => jetzt A/D-Wandlung (klasse Strunterdrckung bei 7-Segmentdisplay!!!)
    ADC_result=ADC_Read(1);									// Kanal 1

    switch (Anode)
        {
        case (0):											// erste (linke) Stelle
            PORTA &= pgm_read_byte(&decode[Digit[1]*2]);	// erste Segmenthlfte decodieren
            if (Digit[0] == 1) cbi (PORTA, PA2);			// 2,5. Stelle = 1? => Segment einschalten
            cbi (PORTA, PA6);								// Dezimalpunkt einschalten
            cbi (PORTB, PB1);								// Anode 1 einschalten
            break;

        case (1):
            PORTA &= pgm_read_byte(&decode[Digit[1]*2+1]);	// zweite Segmenthlfte decodieren
            cbi (PORTB, PB0);								// Anode 2 einschalten
            break;

        case (2):
            PORTA &= pgm_read_byte(&decode[Digit[2]*2]);	// erste Segmenthlfte decodieren
            cbi (PORTA, PA7);								// Anode 3 einschalten
            break;

        case (3):
            PORTA &= pgm_read_byte(&decode[Digit[2]*2+1]);	// zweite Segmenthlfte decodieren
            cbi (PORTB, PB2);								// Anode 4 einschalten
            break;
        }